// dllmain.cpp : Defines the entry point for the DLL application.
#include "stdafx.h"
#include "..\mhook\mhook-lib\mhook.h"
#include <string>
#include <tlhelp32.h>

typedef int(WINAPI *PMessageBox)(
	_In_opt_ HWND hWnd,
	_In_opt_ LPCWSTR lpText,
	_In_opt_ LPCWSTR lpCaption,
	_In_ UINT uType);

PMessageBox g_OriginalMessageBox = (PMessageBox)::GetProcAddress(GetModuleHandle(TEXT("user32.dll")), "MessageBoxW");

int WINAPI HookedMessageBox(_In_opt_ HWND hWnd, _In_opt_ LPCWSTR lpText, _In_opt_ LPCWSTR lpCaption, _In_ UINT uType)
{
	return g_OriginalMessageBox(NULL, L"Hooked text!", L"Hooked Caption", 0);
}

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:		
		Mhook_SetHook((PVOID*)&g_OriginalMessageBox, HookedMessageBox);		
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
	return TRUE;
}

